﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'WebSocket class
'File: Arduino.bas
'Module Type: WebSocket class
'Changed: See readme.txt
Sub Class_Globals
	Private ws As WebSocket
	Private wsconnected As Boolean
End Sub

Public Sub Initialize
'No action	
End Sub

'
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	wsconnected = True
	Main.ConnectedArduino = Me
	Log("Arduino Connected")
End Sub

'Update the chartdata. First save the data to the datafile, followed by updating the connected clients.
'The parameter is a map holding temperature:value and humidity:value
'IMPORTANT: The sub name must include an underscore
Sub Update_ChartData (Params As Map)
	'Save the new chartdata received as parameter 0=temperature, 1=humidity
	Dim t As Double  = Params.Get("temperature")
	Dim h As Double  = Params.Get("humidity")
	'Add the timestamp
	Dim ts As String = DateTime.Time(DateTime.Now)
	'Read the content of the datafile and insert new data at first position in the list
	Dim dl As List 
	If File.Exists(File.DirApp, Main.chartdatafile) = False Then
		dl.Initialize
	Else
		dl = File.ReadList(File.DirApp, Main.chartdatafile)
	End If
	'Insert the new data
	Log($"New Data: ${ts};${t};${h}"$)
	dl.InsertAt(0, $"${ts};${t};${h}"$)
	'Limit to number of  entries defined in main chartdatafilemaxentries
	If dl.Size > Main.chartdatafilemaxentries Then dl.RemoveAt(Main.chartdatafilemaxentries)
	'Save the data to the datafile
	File.WriteList(File.DirApp, Main.chartdatafile, dl)
	
	'Refresh the chart for the connected clients
	For Each br As Browser In Main.ConnectedBrowsers.Keys
		CallSubDelayed2(br, "load_chart", Params)
	Next
End Sub

'Update the measure interval. This is done by sending a function to the Arduiono.
Sub UpdateInterval(interval As Int)
	If wsconnected = False Then Return
	'Must be an array of strings and the parameters cannot include quotes.
	ws.RunFunction(Main.FunctionInterval, Array As String(interval))
	ws.Flush
End Sub

Private Sub WebSocket_Disconnected
	wsconnected = False
End Sub
